'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Popup = require('./Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _Popover = require('../../styles/cspace-layout/Popover.css');

var _Popover2 = _interopRequireDefault(_Popover);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* global window */

var focus = function focus(component) {
  if (component) {
    component.focus();
  }
};

var propTypes = {
  children: _propTypes2.default.node,
  header: _propTypes2.default.node,
  align: _propTypes2.default.string,
  openDelay: _propTypes2.default.number
};

var defaultProps = {
  align: 'left',
  openDelay: 250
};

var Popover = function (_Component) {
  _inherits(Popover, _Component);

  function Popover() {
    _classCallCheck(this, Popover);

    var _this = _possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this));

    _this.handleHeaderClick = _this.handleHeaderClick.bind(_this);
    _this.handleHeaderKeyDown = _this.handleHeaderKeyDown.bind(_this);
    _this.handleHeaderMouseEnter = _this.handleHeaderMouseEnter.bind(_this);
    _this.handleHeaderMouseLeave = _this.handleHeaderMouseLeave.bind(_this);
    _this.handlePopupBlur = _this.handlePopupBlur.bind(_this);
    _this.handlePopupKeyDown = _this.handlePopupKeyDown.bind(_this);
    _this.handlePopupMouseLeave = _this.handlePopupMouseLeave.bind(_this);

    _this.state = {
      open: false
    };
    return _this;
  }

  _createClass(Popover, [{
    key: 'cancelOpen',
    value: function cancelOpen() {
      if (this.openTimer) {
        window.clearTimeout(this.openTimer);

        this.openTimer = null;
      }
    }
  }, {
    key: 'close',
    value: function close() {
      this.cancelOpen();

      this.setState({
        open: false
      });
    }
  }, {
    key: 'open',
    value: function open() {
      this.cancelOpen();

      if (!this.state.open) {
        this.setState({
          open: true
        });
      }
    }
  }, {
    key: 'handleHeaderClick',
    value: function handleHeaderClick(event) {
      event.preventDefault();

      this.open();
    }
  }, {
    key: 'handleHeaderKeyDown',
    value: function handleHeaderKeyDown(event) {
      if (event.key === 'ArrowDown') {
        event.preventDefault();

        this.open();
      }
    }
  }, {
    key: 'handleHeaderMouseEnter',
    value: function handleHeaderMouseEnter() {
      var _this2 = this;

      if (!this.state.open) {
        this.openTimer = setTimeout(function () {
          _this2.open();
        }, this.props.openDelay);
      }
    }
  }, {
    key: 'handleHeaderMouseLeave',
    value: function handleHeaderMouseLeave() {
      this.cancelOpen();
    }
  }, {
    key: 'handlePopupBlur',
    value: function handlePopupBlur() {
      this.close();
    }
  }, {
    key: 'handlePopupKeyDown',
    value: function handlePopupKeyDown(event) {
      if (event.key === 'Escape') {
        this.close();
      }
    }
  }, {
    key: 'handlePopupMouseLeave',
    value: function handlePopupMouseLeave() {
      this.close();
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      var header = this.props.header;


      return _react2.default.createElement(
        'button',
        {
          type: 'button',
          onClick: this.handleHeaderClick,
          onKeyDown: this.handleHeaderKeyDown,
          onMouseEnter: this.handleHeaderMouseEnter,
          onMouseLeave: this.handleHeaderMouseLeave
        },
        header
      );
    }
  }, {
    key: 'renderPopup',
    value: function renderPopup() {
      var children = this.props.children;
      var open = this.state.open;


      if (open && children) {
        return _react2.default.createElement(
          _Popup2.default,
          {
            ref: focus,
            tabIndex: '0',
            onBlur: this.handlePopupBlur,
            onKeyDown: this.handlePopupKeyDown,
            onMouseLeave: this.handlePopupMouseLeave
          },
          children
        );
      }

      return null;
    }
  }, {
    key: 'render',
    value: function render() {
      var align = this.props.align;
      var open = this.state.open;


      var classes = (0, _classnames2.default)(_Popover2.default.common, _Popover2.default[align], _defineProperty({}, _Popover2.default.open, open));

      return _react2.default.createElement(
        'div',
        { className: classes },
        this.renderHeader(),
        this.renderPopup()
      );
    }
  }]);

  return Popover;
}(_react.Component);

exports.default = Popover;


Popover.propTypes = propTypes;
Popover.defaultProps = defaultProps;